#include <iostream>
#include <vector>
#include <sstream>
#include <string>
#include <algorithm>
using namespace std;

// antud kuule eelnev pevade arv. Jaanuarile eelneb 0 peva, veerbruarile 31, mrtsile 31+28 jne
const int kuud[12] = { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334 };

int leiaPaevaNr(string kuupaev) {
    int k = kuupaev.find('.');
    int kuu, paev;
    paev = atoi(kuupaev.substr(0, k).c_str());
    kuu = atoi(kuupaev.substr(k+1, kuupaev.length()).c_str());
    return kuud[kuu-1] + paev;
}

int main()
{
    int M;
    int vahetusi = 0;
    vector<pair<int, int>> vahetused;
    cin >> M;
    while (M--){
        int N, V;
        cin >> N >> V;
        while (V--){
            string algus, lopp;
            cin >> algus >> lopp;
            vahetused.push_back(make_pair(leiaPaevaNr(algus), leiaPaevaNr(lopp)));
        }
    }

    sort(vahetused.begin(), vahetused.end()); // sorteerime alguskuupeva jrgi kasvavalt
    int esimenePaev = 1, viimanePaev = 0, vahetusiKokku = 0;
    int i = 0;

    while (viimanePaev < 365) { // Vahetused on leitud
        // ei ole judnud aasta lppu, aga rohkem vahetusi pole vi
        // jrgmise vaatamata vahetuse esimene pev on liiga kaugel
        if (i == vahetused.size() || vahetused[i].first > esimenePaev) {
            cout << "EI SAA" << endl;
            return 0;
        }
        for (i; i < vahetused.size() && vahetused[i].first <= esimenePaev; i++) {
            if (vahetused[i].second > viimanePaev) { // parem viimane pev
                viimanePaev = vahetused[i].second;
            }
        }
        vahetusiKokku++; // oleme leidnud parima lpp-peva
        esimenePaev = viimanePaev + 1;
    }

    cout << vahetusiKokku << endl;
    return 0;
}
